PLaSK library

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
plask::RectangularMeshBase3D Struct Referenceabstract

`#include <plask/mesh/rectangular_common.hpp>`

Inheritance diagram for plask::RectangularMeshBase3D:
[legend]
Collaboration diagram for plask::RectangularMeshBase3D:
[legend]

## Public Types
typedef plask::Boundary< RectangularMeshBase3D > | Boundary
| Boundary type.
Public Types inherited from plask::MeshD< 3 >
enum |
| Number of dimensions. More...
typedef Primitive< DIM >::DVec | LocalCoords
| Type of vector representing coordinates in local space.
typedef IndexedIterator< const MeshD< dimension >, LocalCoords > | const_iterator
| Random access iterator type which allow iterate over all points in this mesh, in order appointed by operator[].
typedef const_iterator | iterator
typedef const_iterator | Iterator

## Public Member Functions
virtual BoundaryNodeSet | createIndex0BoundaryAtLine (std::size_t line_nr_axis0) const =0
| Create a node set which includes one plane in mesh, which has 0 coordinate equals to `line_nr_axis0`.
virtual BoundaryNodeSet | createIndex0BoundaryAtLine (std::size_t line_nr_axis0, std::size_t index1Begin, std::size_t index1End, std::size_t index2Begin, std::size_t index2End) const =0
| Create a node set which includes a rectangle in plane of mesh, which has 0 coordinate equals to `line_nr_axis0`.
virtual BoundaryNodeSet | createIndex1BoundaryAtLine (std::size_t line_nr_axis1) const =0
| Create a node set which includes one plane in mesh, which has 1 coordinate equals to `line_nr_axis1`.
virtual BoundaryNodeSet | createIndex1BoundaryAtLine (std::size_t line_nr_axis1, std::size_t index0Begin, std::size_t index0End, std::size_t index2Begin, std::size_t index2End) const =0
| Create a node set which includes a rectangle in plane of mesh, which has 0 coordinate equals to `line_nr_axis1`.
virtual BoundaryNodeSet | createIndex2BoundaryAtLine (std::size_t line_nr_axis2) const =0
| Create a node set which includes one plane in mesh, which has 2 coordinate equals to `line_nr_axis2`.
virtual BoundaryNodeSet | createIndex2BoundaryAtLine (std::size_t line_nr_axis2, std::size_t index0Begin, std::size_t index0End, std::size_t index1Begin, std::size_t index1End) const =0
| Create a node set which includes a rectangle in plane of mesh, which has 2 coordinate equals to `line_nr_axis2`.
virtual BoundaryNodeSet | createBackBoundary () const =0
| Create a node set which includes a whole back plane (face) of mesh.
virtual BoundaryNodeSet | createBackOfBoundary (const Box3D &box) const =0
| Create a node set which has fixed index at axis 0 direction and lies on back of the `box` (at nearest plane inside the box).
virtual BoundaryNodeSet | createFrontBoundary () const =0
| Create a node set which includes a whole front plane (face) of mesh.
virtual BoundaryNodeSet | createFrontOfBoundary (const Box3D &box) const =0
| Create a node set which has fixed index at axis 0 direction and lies on front of the `box` (at nearest plane inside the box).
virtual BoundaryNodeSet | createLeftBoundary () const =0
| Create a node set which includes a whole left plane (face) of mesh.
virtual BoundaryNodeSet | createLeftOfBoundary (const Box3D &box) const =0
| Create a node set which has fixed index at axis 1 direction and lies on left face of the `box` (at nearest plane inside the box).
virtual BoundaryNodeSet | createRightBoundary () const =0
| Create a node set which includes a whole right plane (face) of mesh.
virtual BoundaryNodeSet | createRightOfBoundary (const Box3D &box) const =0
| Create a node set which has fixed index at axis 1 direction and lies on right face of the `box` (at nearest plane inside the box).
virtual BoundaryNodeSet | createTopBoundary () const =0
| Create a node set which shows a whole top plane (face) of mesh.
virtual BoundaryNodeSet | createTopOfBoundary (const Box3D &box) const =0
| Create a node set which has fixed index at axis 2 direction and lies on top face of the `box` (at nearest plane inside the box).
virtual BoundaryNodeSet | createBottomBoundary () const =0
| Create a node set which shows a whole bottom plane (face) of mesh.
virtual BoundaryNodeSet | createBottomOfBoundary (const Box3D &box) const =0
| Create a node set which has fixed index at axis 2 direction and lies on bottom face of the `box` (at nearest plane inside the box).
Public Member Functions inherited from plask::MeshD< 3 >
virtual LocalCoords | at (std::size_t index) const=0
| Get point with given mesh index.
LocalCoords | operator[] (std::size_t index) const
| Get point with given mesh index.
const_iterator | begin () const
const_iterator | end () const
| MeshD (const MeshD &PLASK_UNUSED(to_copy))
| Initialize this to be the same as `to_copy` but don't copy any changes observer.
| MeshD ()
MeshD & | operator= (const MeshD &PLASK_UNUSED(to_copy))
| Set this to be the same as `to_copy` but doesn't changed changes observer.
bool | operator== (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
bool | operator!= (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent different sequences of points.
void | print (std::ostream &out) const override
| Print this to stream `out`.
Public Member Functions inherited from plask::Mesh
template<typename ClassT , typename methodT >
boost::signals2::connection | changedConnectMethod (ClassT *obj, methodT method, boost::signals2::connect_position at=boost::signals2::at_back)
| Connect a method to changed signal.
template<typename ClassT , typename methodT >
void | changedDisconnectMethod (ClassT *obj, methodT method)
template<typename EventT = Event, typename ... Args>
void | fireChanged (Args &&... event_constructor_params_without_source)
| Call changed with this as event source.
void | fireResized ()
| This method is called when the mesh is resized.
virtual std::size_t | size () const =0
virtual bool | empty () const
virtual void | writeXML (XMLElement &object) const
| Write mesh to XML.
virtual | ~Mesh ()
Public Member Functions inherited from plask::Printable
virtual | ~Printable ()
std::string | str () const
| Get string representation of this using print method.
Public Member Functions inherited from plask::MeshBase
virtual | ~MeshBase ()

## Static Public Member Functions
template<typename Predicate >
static Boundary | getBoundary (Predicate predicate)
static Boundary | getIndex0BoundaryAtLine (std::size_t line_nr_axis0)
| Get boundary which shows one plane in mesh, which has 0 coordinate equals to `line_nr_axis0`.
static Boundary | getIndex0BoundaryAtLine (std::size_t line_nr_axis0, std::size_t index1Begin, std::size_t index1End, std::size_t index2Begin, std::size_t index2End)
| Get boundary which shows a rectangle in plane of mesh, which has 0 coordinate equals to `line_nr_axis0`.
static Boundary | getIndex1BoundaryAtLine (std::size_t line_nr_axis1)
| Get boundary which shows one plane in mesh, which has 1 coordinate equals to `line_nr_axis1`.
static Boundary | getIndex1BoundaryAtLine (std::size_t line_nr_axis1, std::size_t index0Begin, std::size_t index0End, std::size_t index2Begin, std::size_t index2End)
| Get boundary which shows a rectangle in plane of mesh, which has 1 coordinate equals to `line_nr_axis1`.
static Boundary | getIndex2BoundaryAtLine (std::size_t line_nr_axis2)
| Get boundary which shows one plane in mesh, which has 2 coordinate equals to `line_nr_axis2`.
static Boundary | getIndex2BoundaryAtLine (std::size_t line_nr_axis2, std::size_t index0Begin, std::size_t index0End, std::size_t index1Begin, std::size_t index1End)
| Get boundary which shows a rectangle in plane of mesh, which has 2 coordinate equals to `line_nr_axis2`.
static Boundary | getBackBoundary ()
| Get boundary which show a whole back plane (face) of mesh.
static Boundary | getBackOfBoundary (const Box3D &box)
| Get a boundary which has fixed index at axis 0 direction and lies on back of the `box` (at nearest plane inside the box).
static Boundary | getFrontBoundary ()
| Get boundary which show a whole front plane (face) of mesh.
static Boundary | getFrontOfBoundary (const Box3D &box)
| Get a boundary which has fixed index at axis 0 direction and lies on front of the `box` (at nearest plane inside the box).
static Boundary | getLeftBoundary ()
| Get boundary which show a whole left plane (face) of mesh.
static Boundary | getLeftOfBoundary (const Box3D &box)
| Get a boundary which has fixed index at axis 1 direction and lies on left face of the `box` (at nearest plane inside the box).
static Boundary | getRightBoundary ()
| Get boundary which show a whole right plane (face) of mesh.
static Boundary | getRightOfBoundary (const Box3D &box)
| Get a boundary which has fixed index at axis 1 direction and lies on right face of the `box` (at nearest plane inside the box).
static Boundary | getTopBoundary ()
| Get boundary which show a whole top plane (face) of mesh.
static Boundary | getTopOfBoundary (const Box3D &box)
| Get a boundary which has fixed index at axis 2 direction and lies on top face of the `box` (at nearest plane inside the box).
static Boundary | getBottomBoundary ()
| Get boundary which show a whole bottom plane (face) of mesh.
static Boundary | getBottomOfBoundary (const Box3D &box)
| Get a boundary which has fixed index at axis 2 direction and lies on top bottom of the `box` (at nearest plane inside the box).
static Boundary | getLeftOfBoundary (shared_ptr< const GeometryObject > object, const PathHints &path)
| Get boundary which lies on left faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getLeftOfBoundary (shared_ptr< const GeometryObject > object, const PathHints *path)
| Get boundary which lies on left faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getLeftOfBoundary (shared_ptr< const GeometryObject > object)
| Get boundary which lies on left faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getRightOfBoundary (shared_ptr< const GeometryObject > object, const PathHints &path)
| Get boundary which lies on right faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getRightOfBoundary (shared_ptr< const GeometryObject > object, const PathHints *path)
| Get boundary which lies on right faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getRightOfBoundary (shared_ptr< const GeometryObject > object)
| Get boundary which lies on right faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getBottomOfBoundary (shared_ptr< const GeometryObject > object, const PathHints &path)
| Get boundary which lies on bottom faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getBottomOfBoundary (shared_ptr< const GeometryObject > object, const PathHints *path)
| Get boundary which lies on bottom faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getBottomOfBoundary (shared_ptr< const GeometryObject > object)
| Get boundary which lies on bottom faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getTopOfBoundary (shared_ptr< const GeometryObject > object, const PathHints &path)
| Get boundary which lies on top faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getTopOfBoundary (shared_ptr< const GeometryObject > object)
| Get boundary which lies on top faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getTopOfBoundary (shared_ptr< const GeometryObject > object, const PathHints *path)
| Get boundary which lies on top faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getBackOfBoundary (shared_ptr< const GeometryObject > object, const PathHints &path)
| Get boundary which lies on back faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getBackOfBoundary (shared_ptr< const GeometryObject > object)
| Get boundary which lies on back faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getBackOfBoundary (shared_ptr< const GeometryObject > object, const PathHints *path)
| Get boundary which lies on back of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getFrontOfBoundary (shared_ptr< const GeometryObject > object, const PathHints &path)
| Get boundary which lies on front faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getFrontOfBoundary (shared_ptr< const GeometryObject > object)
| Get boundary which lies on front faces of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getFrontOfBoundary (shared_ptr< const GeometryObject > object, const PathHints *path)
| Get boundary which lies on front of bounding-boxes of `objects` (in `geometry` coordinates).
static Boundary | getBoundary (const std::string &boundary_desc)
static Boundary | getBoundary (XMLReader &boundary_desc, Manager &manager)

## Additional Inherited Members
Public Attributes inherited from plask::Mesh
boost::signals2::signal< void(Event &)> | changed
| Changed signal, fired when mesh was changed.
Protected Member Functions inherited from plask::MeshD< 3 >
virtual bool | hasSameNodes (const MeshD< dimension > &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
Protected Member Functions inherited from plask::Mesh
virtual void | onChange (const Event &evt)
| This method is called when the mesh is changed, just before changed signal.

## Detailed Description

Definition at line 646 of file rectangular_common.hpp.

## Member Typedef Documentation

## ◆ Boundary

typedef plask::Boundary<RectangularMeshBase3D> plask::RectangularMeshBase3D::Boundary

Boundary type.

Definition at line 649 of file rectangular_common.hpp.

## Member Function Documentation

## ◆ createBackBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createBackBoundary | ( |  | ) | const
| pure virtual

Create a node set which includes a whole back plane (face) of mesh.

Returns
  node set which includes a whole back plane (face) of mesh.

Implemented in plask::RectilinearMesh3D.

## ◆ createBackOfBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createBackOfBoundary | ( | const Box3D & | box | ) | const
| pure virtual

Create a node set which has fixed index at axis 0 direction and lies on back of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  node set which includes a back face of the `box`

Implemented in plask::RectilinearMesh3D.

## ◆ createBottomBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createBottomBoundary | ( |  | ) | const
| pure virtual

Create a node set which shows a whole bottom plane (face) of mesh.

Returns
  node set which shows a whole bottom plane (face) of mesh

Implemented in plask::RectilinearMesh3D.

## ◆ createBottomOfBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createBottomOfBoundary | ( | const Box3D & | box | ) | const
| pure virtual

Create a node set which has fixed index at axis 2 direction and lies on bottom face of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  node set which includes a bottom face of the `box`

Implemented in plask::RectilinearMesh3D.

## ◆ createFrontBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createFrontBoundary | ( |  | ) | const
| pure virtual

Create a node set which includes a whole front plane (face) of mesh.

Returns
  node set which includes a whole front plane (face) of mesh.

Implemented in plask::RectilinearMesh3D.

## ◆ createFrontOfBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createFrontOfBoundary | ( | const Box3D & | box | ) | const
| pure virtual

Create a node set which has fixed index at axis 0 direction and lies on front of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  node set which includes a front face of the `box`

Implemented in plask::RectilinearMesh3D.

## ◆ createIndex0BoundaryAtLine() [1/2]

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createIndex0BoundaryAtLine | ( | std::size_t | line_nr_axis0 | ) | const
| pure virtual

Create a node set which includes one plane in mesh, which has 0 coordinate equals to `line_nr_axis0`.

Parameters

  line_nr_axis0 | index of axis[0] mesh

Returns
  node set which includes the plane in mesh

Implemented in plask::RectilinearMesh3D.

## ◆ createIndex0BoundaryAtLine() [2/2]

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createIndex0BoundaryAtLine | ( | std::size_t | line_nr_axis0,
|  | std::size_t | index1Begin,
|  | std::size_t | index1End,
|  | std::size_t | index2Begin,
|  | std::size_t | index2End
| ) |  | const
| pure virtual

Create a node set which includes a rectangle in plane of mesh, which has 0 coordinate equals to `line_nr_axis0`.

Parameters

  line_nr_axis0 | index of axis[0] mesh
  index1Begin,index1End,index2Begin,index2End | indexes which showes rectangle [index1Begin, index1End) x [index2Begin, index2End)

Returns
  node set which includes the plane in mesh

Implemented in plask::RectilinearMesh3D.

## ◆ createIndex1BoundaryAtLine() [1/2]

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createIndex1BoundaryAtLine | ( | std::size_t | line_nr_axis1 | ) | const
| pure virtual

Create a node set which includes one plane in mesh, which has 1 coordinate equals to `line_nr_axis1`.

Parameters

  line_nr_axis0 | index of axis[1] mesh

Returns
  node set which includes the plane in mesh

Implemented in plask::RectilinearMesh3D.

## ◆ createIndex1BoundaryAtLine() [2/2]

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createIndex1BoundaryAtLine | ( | std::size_t | line_nr_axis1,
|  | std::size_t | index0Begin,
|  | std::size_t | index0End,
|  | std::size_t | index2Begin,
|  | std::size_t | index2End
| ) |  | const
| pure virtual

Create a node set which includes a rectangle in plane of mesh, which has 0 coordinate equals to `line_nr_axis1`.

Parameters

  line_nr_axis1 | index of axis[1] mesh
  index0Begin,index0End,index2Begin,index2End | indexes which showes rectangle [index0Begin, index0End) x [index2Begin, index2End)

Returns
  node set which includes includes the plane in mesh

Implemented in plask::RectilinearMesh3D.

## ◆ createIndex2BoundaryAtLine() [1/2]

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createIndex2BoundaryAtLine | ( | std::size_t | line_nr_axis2 | ) | const
| pure virtual

Create a node set which includes one plane in mesh, which has 2 coordinate equals to `line_nr_axis2`.

Parameters

  line_nr_axis2 | index of axis[2] mesh

Returns
  node set which includes the plane in mesh

Implemented in plask::RectilinearMesh3D.

## ◆ createIndex2BoundaryAtLine() [2/2]

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createIndex2BoundaryAtLine | ( | std::size_t | line_nr_axis2,
|  | std::size_t | index0Begin,
|  | std::size_t | index0End,
|  | std::size_t | index1Begin,
|  | std::size_t | index1End
| ) |  | const
| pure virtual

Create a node set which includes a rectangle in plane of mesh, which has 2 coordinate equals to `line_nr_axis2`.

Parameters

  line_nr_axis2 | index of axis[2] mesh
  index0Begin,index0End,index1Begin,index1End | indexes which showes rectangle [index0Begin, index0End) x [index1Begin, index1End)

Returns
  node set which includes includes the plane in mesh

Implemented in plask::RectilinearMesh3D.

## ◆ createLeftBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createLeftBoundary | ( |  | ) | const
| pure virtual

Create a node set which includes a whole left plane (face) of mesh.

Returns
  node set which includes a whole left plane (face) of mesh.

Implemented in plask::RectilinearMesh3D.

## ◆ createLeftOfBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createLeftOfBoundary | ( | const Box3D & | box | ) | const
| pure virtual

Create a node set which has fixed index at axis 1 direction and lies on left face of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  node set which includes a left face of the `box`

Implemented in plask::RectilinearMesh3D.

## ◆ createRightBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createRightBoundary | ( |  | ) | const
| pure virtual

Create a node set which includes a whole right plane (face) of mesh.

Returns
  node set which includes a whole right plane (face) of mesh.

Implemented in plask::RectilinearMesh3D.

## ◆ createRightOfBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createRightOfBoundary | ( | const Box3D & | box | ) | const
| pure virtual

Create a node set which has fixed index at axis 1 direction and lies on right face of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  node set which includes a right face of the `box`

Implemented in plask::RectilinearMesh3D.

## ◆ createTopBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createTopBoundary | ( |  | ) | const
| pure virtual

Create a node set which shows a whole top plane (face) of mesh.

Returns
  node set which shows a whole top plane (face) of mesh

Implemented in plask::RectilinearMesh3D.

## ◆ createTopOfBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase3D::createTopOfBoundary | ( | const Box3D & | box | ) | const
| pure virtual

Create a node set which has fixed index at axis 2 direction and lies on top face of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  node set which includes a top face of the `box`

Implemented in plask::RectilinearMesh3D.

## ◆ getBackBoundary()

static Boundary plask::RectangularMeshBase3D::getBackBoundary | ( |  | ) |
| inline static

Get boundary which show a whole back plane (face) of mesh.

Returns
  boundary which shows a whole back plane (face) of mesh.

Definition at line 795 of file rectangular_common.hpp.

## ◆ getBackOfBoundary() [1/4]

static Boundary plask::RectangularMeshBase3D::getBackOfBoundary | ( | const Box3D & | box | ) |
| inline static

Get a boundary which has fixed index at axis 0 direction and lies on back of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  boundary which includes a back face of the `box`

Definition at line 813 of file rectangular_common.hpp.

## ◆ getBackOfBoundary() [2/4]

static Boundary plask::RectangularMeshBase3D::getBackOfBoundary | ( | shared_ptr< const GeometryObject > | object | ) |
| inline static

Get boundary which lies on back faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1168 of file rectangular_common.hpp.

## ◆ getBackOfBoundary() [3/4]

static Boundary plask::RectangularMeshBase3D::getBackOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints & | path
| ) |  |
| inline static

Get boundary which lies on back faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1155 of file rectangular_common.hpp.

## ◆ getBackOfBoundary() [4/4]

static Boundary plask::RectangularMeshBase3D::getBackOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints * | path
| ) |  |
| inline static

Get boundary which lies on back of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1182 of file rectangular_common.hpp.

## ◆ getBottomBoundary()

static Boundary plask::RectangularMeshBase3D::getBottomBoundary | ( |  | ) |
| inline static

Get boundary which show a whole bottom plane (face) of mesh.

Returns
  boundary which shows a whole bottom plane (face) of mesh

Definition at line 971 of file rectangular_common.hpp.

## ◆ getBottomOfBoundary() [1/4]

static Boundary plask::RectangularMeshBase3D::getBottomOfBoundary | ( | const Box3D & | box | ) |
| inline static

Get a boundary which has fixed index at axis 2 direction and lies on top bottom of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  boundary which includes a bottom face of the `box`

Definition at line 989 of file rectangular_common.hpp.

## ◆ getBottomOfBoundary() [2/4]

static Boundary plask::RectangularMeshBase3D::getBottomOfBoundary | ( | shared_ptr< const GeometryObject > | object | ) |
| inline static

Get boundary which lies on bottom faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1103 of file rectangular_common.hpp.

## ◆ getBottomOfBoundary() [3/4]

static Boundary plask::RectangularMeshBase3D::getBottomOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints & | path
| ) |  |
| inline static

Get boundary which lies on bottom faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1079 of file rectangular_common.hpp.

## ◆ getBottomOfBoundary() [4/4]

static Boundary plask::RectangularMeshBase3D::getBottomOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints * | path
| ) |  |
| inline static

Get boundary which lies on bottom faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1093 of file rectangular_common.hpp.

## ◆ getBoundary() [1/3]

RectangularMeshBase3D::Boundary plask::RectangularMeshBase3D::getBoundary | ( | const std::string & | boundary_desc | ) |
| static

Definition at line 70 of file rectangular_common.cpp.

## ◆ getBoundary() [2/3]

template<typename Predicate >

static Boundary plask::RectangularMeshBase3D::getBoundary | ( | Predicate | predicate | ) |
| inline static

Definition at line 652 of file rectangular_common.hpp.

## ◆ getBoundary() [3/3]

RectangularMeshBase3D::Boundary plask::RectangularMeshBase3D::getBoundary | ( | XMLReader & | boundary_desc,
|  | plask::Manager & | manager
| ) |  |
| static

Definition at line 80 of file rectangular_common.cpp.

## ◆ getFrontBoundary()

static Boundary plask::RectangularMeshBase3D::getFrontBoundary | ( |  | ) |
| inline static

Get boundary which show a whole front plane (face) of mesh.

Returns
  boundary which shows a whole front plane (face) of mesh

Definition at line 830 of file rectangular_common.hpp.

## ◆ getFrontOfBoundary() [1/4]

static Boundary plask::RectangularMeshBase3D::getFrontOfBoundary | ( | const Box3D & | box | ) |
| inline static

Get a boundary which has fixed index at axis 0 direction and lies on front of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  boundary which includes a front face of the `box`

Definition at line 848 of file rectangular_common.hpp.

## ◆ getFrontOfBoundary() [2/4]

static Boundary plask::RectangularMeshBase3D::getFrontOfBoundary | ( | shared_ptr< const GeometryObject > | object | ) |
| inline static

Get boundary which lies on front faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1206 of file rectangular_common.hpp.

## ◆ getFrontOfBoundary() [3/4]

static Boundary plask::RectangularMeshBase3D::getFrontOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints & | path
| ) |  |
| inline static

Get boundary which lies on front faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1193 of file rectangular_common.hpp.

## ◆ getFrontOfBoundary() [4/4]

static Boundary plask::RectangularMeshBase3D::getFrontOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints * | path
| ) |  |
| inline static

Get boundary which lies on front of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1220 of file rectangular_common.hpp.

## ◆ getIndex0BoundaryAtLine() [1/2]

static Boundary plask::RectangularMeshBase3D::getIndex0BoundaryAtLine | ( | std::size_t | line_nr_axis0 | ) |
| inline static

Get boundary which shows one plane in mesh, which has 0 coordinate equals to `line_nr_axis0`.

Parameters

  line_nr_axis0 | index of axis[0] mesh

Returns
  boundary which shows plane in mesh

Definition at line 668 of file rectangular_common.hpp.

## ◆ getIndex0BoundaryAtLine() [2/2]

static Boundary plask::RectangularMeshBase3D::getIndex0BoundaryAtLine | ( | std::size_t | line_nr_axis0,
|  | std::size_t | index1Begin,
|  | std::size_t | index1End,
|  | std::size_t | index2Begin,
|  | std::size_t | index2End
| ) |  |
| inline static

Get boundary which shows a rectangle in plane of mesh, which has 0 coordinate equals to `line_nr_axis0`.

Parameters

  line_nr_axis0 | index of axis[0] mesh
  index1Begin,index1End,index2Begin,index2End | indexes which showes rectangle [index1Begin, index1End) x [index2Begin, index2End)

Returns
  boundary which shows the plane in mesh

Definition at line 691 of file rectangular_common.hpp.

## ◆ getIndex1BoundaryAtLine() [1/2]

static Boundary plask::RectangularMeshBase3D::getIndex1BoundaryAtLine | ( | std::size_t | line_nr_axis1 | ) |
| inline static

Get boundary which shows one plane in mesh, which has 1 coordinate equals to `line_nr_axis1`.

Parameters

  line_nr_axis1 | index of axis[1] mesh

Returns
  boundary which shows plane in mesh

Definition at line 711 of file rectangular_common.hpp.

## ◆ getIndex1BoundaryAtLine() [2/2]

static Boundary plask::RectangularMeshBase3D::getIndex1BoundaryAtLine | ( | std::size_t | line_nr_axis1,
|  | std::size_t | index0Begin,
|  | std::size_t | index0End,
|  | std::size_t | index2Begin,
|  | std::size_t | index2End
| ) |  |
| inline static

Get boundary which shows a rectangle in plane of mesh, which has 1 coordinate equals to `line_nr_axis1`.

Parameters

  line_nr_axis0 | index of axis[1] mesh
  index0Begin,index0End,index2Begin,index2End | indexes which showes rectangle [index0Begin, index0End) x [index2Begin, index2End)

Returns
  boundary which shows the plane in mesh

Definition at line 734 of file rectangular_common.hpp.

## ◆ getIndex2BoundaryAtLine() [1/2]

static Boundary plask::RectangularMeshBase3D::getIndex2BoundaryAtLine | ( | std::size_t | line_nr_axis2 | ) |
| inline static

Get boundary which shows one plane in mesh, which has 2 coordinate equals to `line_nr_axis2`.

Parameters

  line_nr_axis2 | index of axis[2] mesh

Returns
  boundary which shows plane in mesh

Definition at line 754 of file rectangular_common.hpp.

## ◆ getIndex2BoundaryAtLine() [2/2]

static Boundary plask::RectangularMeshBase3D::getIndex2BoundaryAtLine | ( | std::size_t | line_nr_axis2,
|  | std::size_t | index0Begin,
|  | std::size_t | index0End,
|  | std::size_t | index1Begin,
|  | std::size_t | index1End
| ) |  |
| inline static

Get boundary which shows a rectangle in plane of mesh, which has 2 coordinate equals to `line_nr_axis2`.

Parameters

  line_nr_axis2 | index of axis[2] mesh
  index0Begin,index0End,index1Begin,index1End | indexes which showes rectangle [index0Begin, index0End) x [index1Begin, index1End)

Returns
  boundary which shows the plane in mesh

Definition at line 777 of file rectangular_common.hpp.

## ◆ getLeftBoundary()

static Boundary plask::RectangularMeshBase3D::getLeftBoundary | ( |  | ) |
| inline static

Get boundary which show a whole left plane (face) of mesh.

Returns
  boundary which shows a whole left plane (face) of mesh

Definition at line 865 of file rectangular_common.hpp.

## ◆ getLeftOfBoundary() [1/4]

static Boundary plask::RectangularMeshBase3D::getLeftOfBoundary | ( | const Box3D & | box | ) |
| inline static

Get a boundary which has fixed index at axis 1 direction and lies on left face of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  boundary which includes a left face of the `box`

Definition at line 883 of file rectangular_common.hpp.

## ◆ getLeftOfBoundary() [2/4]

static Boundary plask::RectangularMeshBase3D::getLeftOfBoundary | ( | shared_ptr< const GeometryObject > | object | ) |
| inline static

Get boundary which lies on left faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1027 of file rectangular_common.hpp.

## ◆ getLeftOfBoundary() [3/4]

static Boundary plask::RectangularMeshBase3D::getLeftOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints & | path
| ) |  |
| inline static

Get boundary which lies on left faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1003 of file rectangular_common.hpp.

## ◆ getLeftOfBoundary() [4/4]

static Boundary plask::RectangularMeshBase3D::getLeftOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints * | path
| ) |  |
| inline static

Get boundary which lies on left faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1017 of file rectangular_common.hpp.

## ◆ getRightBoundary()

static Boundary plask::RectangularMeshBase3D::getRightBoundary | ( |  | ) |
| inline static

Get boundary which show a whole right plane (face) of mesh.

Returns
  boundary which shows a whole right plane (face) of mesh

Definition at line 901 of file rectangular_common.hpp.

## ◆ getRightOfBoundary() [1/4]

static Boundary plask::RectangularMeshBase3D::getRightOfBoundary | ( | const Box3D & | box | ) |
| inline static

Get a boundary which has fixed index at axis 1 direction and lies on right face of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  boundary which includes a right face of the `box`

Definition at line 919 of file rectangular_common.hpp.

## ◆ getRightOfBoundary() [2/4]

static Boundary plask::RectangularMeshBase3D::getRightOfBoundary | ( | shared_ptr< const GeometryObject > | object | ) |
| inline static

Get boundary which lies on right faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1065 of file rectangular_common.hpp.

## ◆ getRightOfBoundary() [3/4]

static Boundary plask::RectangularMeshBase3D::getRightOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints & | path
| ) |  |
| inline static

Get boundary which lies on right faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1041 of file rectangular_common.hpp.

## ◆ getRightOfBoundary() [4/4]

static Boundary plask::RectangularMeshBase3D::getRightOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints * | path
| ) |  |
| inline static

Get boundary which lies on right faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1055 of file rectangular_common.hpp.

## ◆ getTopBoundary()

static Boundary plask::RectangularMeshBase3D::getTopBoundary | ( |  | ) |
| inline static

Get boundary which show a whole top plane (face) of mesh.

Returns
  boundary which shows a whole top plane (face) of mesh

Definition at line 936 of file rectangular_common.hpp.

## ◆ getTopOfBoundary() [1/4]

static Boundary plask::RectangularMeshBase3D::getTopOfBoundary | ( | const Box3D & | box | ) |
| inline static

Get a boundary which has fixed index at axis 2 direction and lies on top face of the `box` (at nearest plane inside the box).

Parameters

  box | box in which boundary should lie

Returns
  boundary which includes a top face of the `box`

Definition at line 954 of file rectangular_common.hpp.

## ◆ getTopOfBoundary() [2/4]

static Boundary plask::RectangularMeshBase3D::getTopOfBoundary | ( | shared_ptr< const GeometryObject > | object | ) |
| inline static

Get boundary which lies on top faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1130 of file rectangular_common.hpp.

## ◆ getTopOfBoundary() [3/4]

static Boundary plask::RectangularMeshBase3D::getTopOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints & | path
| ) |  |
| inline static

Get boundary which lies on top faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1117 of file rectangular_common.hpp.

## ◆ getTopOfBoundary() [4/4]

static Boundary plask::RectangularMeshBase3D::getTopOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints * | path
| ) |  |
| inline static

Get boundary which lies on top faces of bounding-boxes of `objects` (in `geometry` coordinates).

Parameters

  geometry | geometry, needs to define coordinates, geometry which is used with the mesh
  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries on faces of `object's` bounding-boxes

Definition at line 1144 of file rectangular_common.hpp.

The documentation for this struct was generated from the following files:

- plask/mesh/rectangular_common.hpp
- plask/mesh/rectangular_common.cpp